# This is the continuation of the old alpha host but with much cleaner code
# and less manual infra setup involved. Key differences are that block storage
# is now completely kept in this module instead of yolo'd out like before.

######################### SSH KEY ##############################################
resource "aws_key_pair" "atlas_ssh" {
  key_name = var.atlas_ssh_key_name
  public_key = file(var.atlas_public_key_path)
}

######################### files.leftcoast.space VOLUME #########################
resource "aws_ebs_volume" "files-leftcoast-space" {
  availability_zone = var.athens_availability_zone
  size = 30

  tags = {
    Name = "files.leftcoast.space-ebs"
    Description = "Volume is to be used entirely for Photos/Video"
  }
}

######################### clips.shockrah.xyz VOLUME ############################
resource "aws_ebs_volume" "clips-shockrah-xyz" {
  availability_zone = var.athens_availability_zone
  size = 30

  tags = {
    Name = "clips.shockrah.xyz-ebs"
    Description = "Used for the clippable instance"
  }
}

######################### ATTACHMENT FOR files.leftcoast.space #################
resource "aws_volume_attachment" "files-leftcoast-space" {
  device_name = "/dev/sdf"
  volume_id = aws_ebs_volume.files-leftcoast-space.id
  instance_id = aws_instance.atlas.id
}


######################### ATTACHMENT FOR clips.shockrah.xyz ####################
resource "aws_volume_attachment" "clips-shockrah-xyz" {
  device_name = "/dev/sdg"
  volume_id = aws_ebs_volume.clips-shockrah-xyz.id
  instance_id = aws_instance.atlas.id
}

######################### INSTANCE CONFIGURATION ###############################
resource "aws_instance" "atlas" {
  ami = var.atlas_ami_id
  instance_type = var.atlas_instance_type

  key_name = var.atlas_ssh_key_name

  private_ip = "10.0.1.20"
  vpc_security_group_ids = [ 
    aws_security_group.general_web_req.id,
    aws_security_group.remote_ssh_rec.id
  ]
  subnet_id = aws_subnet.crete_subnet.id
  tags = {
    Name = "Atlas Host"
    Description = "Simple Docker host for some personal stuff"
  }

}
